package examples.hibernate.dao;

import java.util.List;
import examples.hibernate.entity.Employee;

public interface EmployeeAutoDao {

	public Class BEAN = Employee.class;

	//ǉA폜AXVAۑorXVꍇ
	public void save(Employee employee);
	public void delete(Employee employee);
	public void update(Employee employee);
	public void saveOrUpdate(Employee employee);
	
	//HQLw肵ȂŎsꍇ
	public String getEmployeeByEmpNo_ARGS = "empno";
	public Employee getEmployeeByEmpNo(long empNo);

	public String getEmployeeByJobDeptno_ARGS = "job, deptno";
	public List getEmployeeByJobDeptno(String job, short deptno);
	
	//HQLw肵Ďsꍇ
	public String getHQLAllEmployee_HQL = "from Employee emp order by emp.empno";
	public List getHQLAllEmployee();

	//w肵ĂȂꍇ
	public List getAllEmployee();

	//firstResult,maxResultsw肷ꍇ
	public String getEmployeeList_ARGS = "firstResult,maxResults";
	public String getEmployeeList_HQL = "from Employee emp order by emp.empno";
	public List getEmployeeList(int firstResult ,int MaxResults );

	//߂lint̏ꍇ
	public String getEmployeeCount_HQL = "select count(emp) from Employee emp";
	public int getEmployeeCount();

	//߂lString̏ꍇ
	public String getEmployeeNameById_HQL 
				= "select emp.ename from Employee emp where empno = :employeeId ";
	public String getEmployeeNameById_ARGS = "employeeId";
	public String getEmployeeNameById(Long employeeId);

	//NamedQueryĂяogꍇ
	//(Employee.hbm.xml"examples.hibernate.dao.EmployeeAutoDao_getEmployeeByJob"ɑΉ)
	public String getEmployeeByJob_ARGS = "job";
	public List getEmployeeByJob(String job);

	//NamedQueryŖ߂lStringɂȂ悤SQLgꍇ
	//(Employee.hbm.xml"examples.hibernate.dao.EmployeeAutoDao_getSQLEmployeeNameById"ɑΉ)
	public String getSQLEmployeeNameById_ARGS = "employeeId";
	public String getSQLEmployeeNameById(Long employeeId);	
	
	//NamedQueryŖ߂lLongɂȂ悤SQLgꍇ
	//(Employee.hbm.xml"getSQLEmployeeIdByName"NamedQuerys)
	public String getSQLEmployeeIdByName_ARGS = "employeeName";
	public Long getSQLEmployeeIdByName(String employeeName);
}
